﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using ImagEncode.Services;
using Microsoft.AspNetCore.Mvc;
using SixLabors.ImageSharp;
using SixLabors.ImageSharp.Formats.Png;
using SixLabors.ImageSharp.PixelFormats;

namespace ImagEncode.Controllers {
    public class ImageController : Controller {
        private readonly ICodePictureGenerator<Rgb24> generator;

        public ImageController(ICodePictureGenerator<Rgb24> generator) {
            this.generator = generator;
        }

        [Route("/test")]
        public IActionResult Test() => this.Ok("TEST");

        [Route("/code/{width:int}/{height:int}/image.png")]
        public IActionResult GetImage(int width, int height,[FromQuery] string text) {
            var img = this.generator.CreateImage(text, new SixLabors.Primitives.Size(width, height));
            var ms = new System.IO.MemoryStream();
            img.SaveAsPng(ms);
            ms.Seek(0, System.IO.SeekOrigin.Begin);
            return new FileStreamResult(ms, "image/png");

        }

    }
}
