﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using ImagEncode.Services;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.DependencyInjection;
using SixLabors.ImageSharp.PixelFormats;

namespace ImagEncode {
    public class Startup {
        public void ConfigureServices(IServiceCollection services) {
            services.AddMvc();
            services.Configure<BinaryCodePictureGeneratorOptions<Rgb24>>(options => {
                options.BackgroundColor = new Rgb24(0xFF, 0x00, 0x00);
                options.ForegroundColor = new Rgb24(0xFE, 0x00, 0x00);
                options.ModuleSize = new SixLabors.Primitives.Size(1, 1);
                options.VerticalSpacing = 0;
            });
            services.AddTransient<ICodePictureGenerator<Rgb24>, BinaryCodePictureGenerator<Rgb24>>();
        }

        public void Configure(IApplicationBuilder app, IHostingEnvironment env) {
            if (env.IsDevelopment()) {
                app.UseDeveloperExceptionPage();
            }

            app.UseStaticFiles();
            app.UseMvc();
        }
    }
}
